PGOBLIN_BANG(-f)
  Copyright (C)2022 @BABOLO http://www.babolo.ru/
  pkg = cipalite
  All rights reserved.

  Redistribution and use in source and binary forms, with or without
  modification, are permitted provided that the following conditions
  are met:
  1. Redistributions of source code must retain the above copyright
     notice, this list of conditions and the following disclaimer.
  2. Redistributions in binary form must reproduce the above copyright
     notice, this list of conditions and the following disclaimer in the
     documentation and/or other materials provided with the distribution.

  THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
  ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
  ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
  FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
  DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
  OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
  HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
  LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
  OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  SUCH DAMAGE.

  $Id: cipalite.pgoblin.m4,v 1.27 2022/10/22 11:18:22 babolo Exp $

#job
local -zz
#connect 0002
sqlite3 CIPALITEVAR/PROTOVER.sqlite
#perform 0002
PRAGMA foreign_keys = 1;
#perform 0002
PRAGMA temp_store = 2;
#perform 0002
PRAGMA journal_mode = WAL;
#perform 0002
PRAGMA application_id = 0x43495041;
#connect 0003
sqlite3 CIPALITEVAR/PROTOVER.sess.sqlite
#perform 0003
PRAGMA foreign_keys = 1;
#perform 0003
PRAGMA temp_store = 2;
#perform 0003
PRAGMA journal_mode = WAL;
#perform 0003
PRAGMA application_id = 0x43495041;
#perform 0002  #######################################################      ####
CREATE TEMP TABLE v(v real) STRICT;
#cat     _
PREFIX/include/babolo/PKG:PROTOVER.VERSION
#trap
#echo
@@@Ignore it

#perform 0002
INSERT INTO v VALUES(NULL);
#return
#copyin  00_2
COPY v;
#untrap
#wait
#close   _0_
#select  _002
SELECT rootpage
 FROM SQLITE_MASTER
 WHERE type == 'table' AND name == SQNM(version) AND tbl_name = SQNM(version)
;
#select  00_2
SELECT 'PKG'
     , ':' || NULLIF('PROTOVER', '')
     , '=VERS'
     , ' File=' || CAST(v.v AS TEXT)
     , (SELECT ' DB=' || CAST(SQNM(version).SQAT(major) AS TEXT) || '.' || SQNM(version).SQAT(minor)
         FROM SQNM(version)
         WHERE SQNM(version).SQAT(pkg) == 'PKG'
           AND COALESCE(SQNM(version).SQAT(protover) IS NULLIF('PROTOVER', ''), 1)
        LIMIT 1
       )
     , ' %%%%%%%%%%%%%%%%
'FROM v CROSS JOIN SQNM(version)
 WHERE SQNM(version).SQAT(pkg) == 'PKG'
   AND COALESCE(SQNM(version).SQAT(protover) == NULLIF('PROTOVER', ''), 1)
;
#close   _0_
#perform 0002  ##########################################################     ####
CREATE TABLE IF NOT EXISTS SQNM(ciparam)
     ( SQAT(m)      text
     , SQAT(v)      text
     , SQAT(param)  text
     , PRIMARY KEY(SQAT(m), SQAT(v))
     ) STRICT
;
#perform 0002  ########################################        ####
CREATE TABLE IF NOT EXISTS SQNM(version) --   
     ( SQAT(pkg)      text NOT NULL         --  
     , SQAT(protover) text                  --  
     , SQAT(major)    int  NOT NULL         --  
     , SQAT(minor)    text NOT NULL         --  
     , SQAT(comconf)  int                   --  
     , UNIQUE(SQAT(pkg), SQAT(protover)) ON CONFLICT REPLACE
     ) STRICT
;
#perform 0002
CREATE UNIQUE INDEX IF NOT EXISTS SQNM(version_p)
 ON SQNM(version)(SQAT(pkg))
 WHERE SQAT(protover) IS NULL
;
#perform 0002  ################################################################     ####
CREATE TABLE IF NOT EXISTS SQNM(srcs) --   
     ( SQAT(pkg)      text NOT NULL      --  
     , SQAT(major)    int  NOT NULL      --  
     , SQAT(minor)    text NOT NULL      --  
     , PRIMARY KEY(SQAT(pkg), SQAT(major))
     ) STRICT
;
#perform 0002  ###########################################################################    ####
CREATE VIEW IF NOT EXISTS SQNM(babolover) AS --  
 WITH s AS(SELECT SQAT(pkg), MAX(SQAT(major)) AS SQAT(major), SQAT(minor)
            FROM SQNM(srcs)
           GROUP BY SQAT(pkg)
          )
 SELECT SQAT(pkg)                               --  
      , SQAT(protover)                          --  
      , s.SQAT(major)           AS SQAT(smj)    --   
      , s.SQAT(minor)            AS SQAT(smi)   --   
      , SQNM(version).SQAT(major) AS SQAT(vmj)  --   
      , SQNM(version).SQAT(minor)  AS SQAT(vmi) --   
      , SQAT(comconf)                           --  
  FROM s LEFT JOIN SQNM(version) USING(SQAT(pkg))
UNION
 SELECT SQAT(pkg)
      , SQNM(version).SQAT(protover)
      , NULL
      , NULL
      , SQNM(version).SQAT(major)
      , SQNM(version).SQAT(minor)
      , SQNM(version).SQAT(comconf)
  FROM SQNM(version) LEFT JOIN s USING(SQAT(pkg))
  WHERE s.SQAT(pkg) IS NULL
;
#perform 0003  #####################################################################    ####
CREATE TABLE IF NOT EXISTS SQNM(pass)
     ( SQAT(cred)     INTEGER PRIMARY KEY     --  
     , SQAT(context)  text    NOT NULL           -- 
     , SQAT(login)    text    NOT NULL           -- 
     , SQAT(passwd)   text                       -- 
     , SQAT(srcip)    text                       -- IP,      cred
     , SQAT(flags)    int     NOT NULL DEFAULT 0 -- 
                                                    --  1   sess
                                                    --  2   sess
                                                    --  4   sess
                                                    --  8   sess
                      --      PassClaimPass         -- 16   
                      --      PassAuthName          -- 32    AuthName
     , SQAT(ttl)      int                        --   
     , SQAT(hzone)    int                        --  tz, 
     , SQAT(mzone)    int                        --  tz, 
     , SQAT(remark)   text                       -- 
     , SQAT(nickname) text                       --  
     ) STRICT
;
#perform 0003
CREATE UNIQUE INDEX IF NOT EXISTS SQNM(pass_cl) ON SQNM(pass)(SQAT(context), SQAT(login));
#perform 0003  ##########################################################################    ####
CREATE TABLE IF NOT EXISTS SQNM(sess)                        --  
     ( SQAT(sess)    INTEGER PRIMARY KEY                        --  
     , SQAT(cred)    int     REFERENCES SQNM(pass)              --   pass
     , SQAT(cnt)     int     NOT NULL DEFAULT 0                 --  
     , SQAT(srcip)   text                                       -- IP,   
     , SQAT(flags)   int     NOT NULL DEFAULT 0                 -- 
                     --      SessClaimPass                         -- 1   
                     --      SessAuthName                          -- 2    AuthName
     , SQAT(login)   text                                       --  
     , SQAT(pass)    text                                       --  
     , SQAT(ttl)     real                                       --   
     , SQAT(hzone)   int                                        --  tz, 
     , SQAT(mzone)   int                                        --  tz, 
     , SQAT(created) real    NOT NULL -- DEFAULT gettimeofday() --   
     , SQAT(updated) real    NOT NULL -- DEFAULT gettimeofday() --   
     ) STRICT
;
#perform 0003
CREATE TABLE IF NOT EXISTS SQNM(sessb)                       --  
     ( SQAT(sess)    INTEGER PRIMARY KEY                        --  
     , SQAT(cred)    int     REFERENCES SQNM(pass)              --   pass
     , SQAT(cnt)     int     NOT NULL DEFAULT 1                 --  
     , SQAT(srcip)   text                                       -- IP,   
     , SQAT(flags)   int     NOT NULL DEFAULT 0                 -- 
     , SQAT(login)   text                                       --  
     , SQAT(pass)    text                                       --  
     , SQAT(ttl)     real                                       --   
     , SQAT(hzone)   int                                        --  tz, 
     , SQAT(mzone)   int                                        --  tz, 
     , SQAT(created) real    NOT NULL -- DEFAULT gettimeofday() --   
     , SQAT(updated) real    NOT NULL -- DEFAULT gettimeofday() --   
     , SQAT(removed) real    NOT NULL -- DEFAULT gettimeofday() --   
     ) STRICT
;
#perform 0003
CREATE INDEX IF NOT EXISTS SQNM(sess_c) ON SQNM(sess)(SQAT(cred), SQAT(sess));
#select  v002  ############################################################################  pkey  ####
SELECT 1 FROM v WHERE v < 0.08;
#perform 00v3
DROP TABLE IF EXISTS SQNM(pkey);
#perform 0003
CREATE TABLE IF NOT EXISTS SQNM(pkey)
     ( SQAT(pkey)    INTEGER PRIMARY KEY                        --  
     , SQAT(sess)    int  REFERENCES SQNM(sess) ON DELETE CASCADE --  
     , SQAT(created) real NOT NULL -- DEFAULT gettimeofday()      --   
     , SQAT(ttl)     real                                         --   
     ) STRICT
;
#close   0003  ###############################################     sess    ####
#perform 0002
ATTACH 'CIPALITEVAR/PROTOVER.sess.sqlite' AS DBsess
#select  _002
SELECT rootpage
 FROM SQLITE_MASTER
 WHERE type == 'table' AND name == SQNM(pass) AND tbl_name = SQNM(pass)
;
#eval    00_
##perform 0002
PRAGMA foreign_keys = 0;
##perform 0002
DELETE FROM DBsess.SQNM(pass);
##perform 0002
DELETE FROM DBsess.SQNM(sess);
##perform 0002
DELETE FROM DBsess.SQNM(sessb);
##perform 0002
DELETE FROM DBsess.SQNM(pkey);
##begin   0002
##perform 0002
INSERT INTO DBsess.SQNM(sessb) SELECT * FROM SQNM(sessb);
##perform 0002
INSERT INTO DBsess.SQNM(pkey) SELECT * FROM SQNM(pkey);
##perform 0002
INSERT INTO DBsess.SQNM(sess) SELECT * FROM SQNM(sess);
##perform 0002
INSERT INTO DBsess.SQNM(pass) SELECT * FROM SQNM(pass);
##perform 0002
DROP TABLE SQNM(pkey);
##perform 0002
DROP TABLE SQNM(sessb);
##perform 0002
DROP TABLE SQNM(sess);
##perform 0002
DROP TABLE SQNM(pass);
##end     0002
##perform 0002
PRAGMA foreign_keys = 1;
#perform 0002
INSERT INTO DBsess.SQNM(pass)(SQAT(cred), SQAT(context), SQAT(login), SQAT(passwd), SQAT(flags))
 SELECT 0, 'PROTOVER', '', NULL, SessClaimPass | SessAuthName | PassAuthName
  WHERE NOT EXISTS(SELECT 1 FROM DBsess.SQNM(pass))
;
#perform 0002  ############################################################################  post  ####
CREATE TABLE IF NOT EXISTS SQNM(post)                         -- 
     ( SQAT(post)    INTEGER PRIMARY KEY AUTOINCREMENT          --  
     , SQAT(sess)    int  -- REFERENCES SQNM(sess)              --  
     , SQAT(refs)    int     REFERENCES SQNM(post)              --    
     , SQAT(created) real    NOT NULL -- DEFAULT gettimeofday() --   
     , SQAT(flags)   int     NOT NULL DEFAULT 0                 -- 
                     --      PostToRede                            -- 1   
     , SQAT(mess)    text                                       --  
     ) STRICT
;
#perform 0002
CREATE INDEX IF NOT EXISTS SQNM(post_s) ON SQNM(post)(SQAT(sess));
#perform 0002  ########################################################################  cipaconf  ####
CREATE TABLE IF NOT EXISTS SQNM(cipaconf)
     ( SQAT(a1)   int
     , SQAT(a2)   int
     , SQAT(a3)   int
     , SQAT(ttl)  real
     ) STRICT
;
#perform 0002 -- ((sess * a3) + a2) % a1 
INSERT INTO SQNM(cipaconf) -- 9223372036854775417, 9223372036854759307, 7223372036854775311
 SELECT 1073741825, 1073741101, 955835743, 1800.0
  WHERE NOT EXISTS(SELECT 1 FROM SQNM(cipaconf))
;
#exec
/usr/bin/chgrp
#
www
#
CIPALITEVAR
#exec
/bin/chmod
#
g+w
#
CIPALITEVAR
#exec
/usr/sbin/chown
#
www:www
#
CIPALITEVAR/PROTOVER.sqlite
#exec
/usr/sbin/chown
#
www:www
#
CIPALITEVAR/PROTOVER.sess.sqlite
#wait
